%{
/*
   This file is part of the index package,
   Copyright (C) 1997 Harold Tay, haroldtay@pacific.net.sg

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
   02111-1307, USA
 */
/* Scanner to get words from a tn article file.
 */
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <errno.h>
#include <unistd.h>
#include <fcntl.h>
#include <sys/mman.h>
#include <sys/stat.h>
#include <ctype.h>

extern void putword(char *);
extern void putmessageid(char *);
extern int getinput(char * buf, int max);
int min_word_length = 3;
int max_word_length = 15;

#define YY_INPUT(b,r,m) (r = getinput(b, m))

%}

%x BODY EAT

word [a-z0-9]+
worthless1 article.*<[^@]*@[a-z0-9.]*>.*[:.]
worthless2 message.*<[^@]*@[a-z0-9.]*>.*[:.]
worthless3 post.*<[^@]*@[a-z0-9.]*>.*[:.]
contraction [a-z]+'[ts]
base64 ^[a-z0-9+/]+=?\r\n

%%

<INITIAL>\r\n\r\n        {
                           BEGIN(BODY);
                         }

<INITIAL>^Message-id:.*$ {
                           putmessageid(yytext);
                           BEGIN(EAT);
                         }
<INITIAL>.|\n            ;

<EAT>\r\n\r\n            {
                           BEGIN(BODY);
                         }
<EAT>.|\n                ;

<BODY>{worthless1}       ;
<BODY>{worthless2}       ;
<BODY>{worthless3}       ;
<BODY>{contraction}      ;
<BODY>{base64} ;
<BODY>the ;
<BODY>and ;
<BODY>for ;
<BODY>you ;
<BODY>that ;
<BODY>wrote ;
<BODY>with ;
<BODY>have ;
<BODY>this ;
<BODY>com ;
<BODY>are ;
<BODY>not ;
<BODY>but ;
<BODY>can ;
<BODY>from ;
<BODY>your ;
<BODY>all ;
<BODY>one ;
<BODY>what ;
<BODY>will ;
<BODY>there ;
<BODY>would ;
<BODY>any ;
<BODY>they ;
<BODY>like ;
<BODY>was ;
<BODY>http ;
<BODY>about ;
<BODY>just ;
<BODY>has ;
<BODY>more ;
<BODY>www ;
<BODY>some ;
<BODY>out ;
<BODY>only ;
<BODY>get ;
<BODY>how ;
<BODY>know ;
<BODY>which ;
<BODY>when ;
<BODY>other ;
<BODY>use ;
<BODY>please ;
<BODY>time ;
<BODY>also ;
<BODY>then ;
<BODY>good ;
<BODY>1997 ;
<BODY>who ;
<BODY>than ;
<BODY>does ;
<BODY>them ;
<BODY>now ;
<BODY>very ;
<BODY>want ;
<BODY>need ;
<BODY>should ;
<BODY>been ;
<BODY>see ;
<BODY>could ;
<BODY>way ;
<BODY>anyone ;
<BODY>their ;
<BODY>where ;
<BODY>thanks ;
<BODY>into ;
<BODY>because ;
<BODY>here ;
<BODY>these ;
<BODY>had ;
<BODY>much ;
<BODY>why ;
<BODY>most ;
<BODY>may ;
<BODY>used ;
<BODY>many ;
<BODY>same ;
<BODY>two ;
<BODY>too ;
<BODY>first ;
<BODY>problem ;
<BODY>still ;
<BODY>our ;
<BODY>really ;
<BODY>over ;
<BODY>must ;
<BODY>something ;
<BODY>those ;
<BODY>were ;
<BODY>say ;
<BODY>such ;
<BODY>take ;
<BODY>his ;
<BODY>before ;
<BODY>call ;
<BODY>after ;
<BODY>looking ;
<BODY>try ;
<BODY>off ;
<BODY>another ;
<BODY>both ;
<BODY>since ;
<BODY>being ;
<BODY>better ;
<BODY>while ;
<BODY>through ;
<BODY>did ;
<BODY>its ;
<BODY>without ;
<BODY>etc ;
<BODY>thing ;
<BODY>got ;
<BODY>writes ;
<BODY>might ;
<BODY>made ;
<BODY>own ;
<BODY>going ;
<BODY>look ;
<BODY>around ;
<BODY>give ;
<BODY>following ;
<BODY>long ;
<BODY>sure ;
<BODY>actually ;
<BODY>day ;
<BODY>send ;
<BODY>few ;
<BODY>either ;
<BODY>things ;
<BODY>down ;
<BODY>put ;
<BODY>however ;
<BODY>above ;
<BODY>come ;
<BODY>anything ;
<BODY>said ;
<BODY>tell ;
<BODY>real ;
<BODY>every ;
<BODY>enough ;
<BODY>always ;
<BODY>again ;
<BODY>yes ;
<BODY>high ;
<BODY>ever ;
<BODY>says ;
<BODY>great ;
<BODY>let ;
<BODY>least ;
<BODY>probably ;
<BODY>him ;
<BODY>though ;
<BODY>yet ;
<BODY>seems ;
<BODY>check ;
<BODY>done ;
<BODY>else ;
<BODY>able ;
<BODY>keep ;
<BODY>possible ;
<BODY>under ;
<BODY>times ;
<BODY>thank ;
<BODY>getting ;
<BODY>doing ;
<BODY>maybe ;
<BODY>comes ;
<BODY>away ;
<BODY>rather ;
<BODY>having ;
<BODY>big ;
<BODY>written ;
<BODY>once ;
<BODY>less ;
<BODY>hand ;
<BODY>job ;
<BODY>next ;
<BODY>word ;
<BODY>change ;
<BODY>quite ;
<BODY>regards ;
<BODY>makes ;
<BODY>open ;
<BODY>seen ;
<BODY>{word}             {
                           putword(yytext);
                         }

<BODY>.|\n               ;

<BODY><<EOF>>            {
                           BEGIN(INITIAL);
                         }



%%

static char * map = NULL;
static int used = 0;
static int flag_for_yywrap = 0;

static int
copyn(char * to, char * from, int n)
{
  char * p = from;
  while( (*to++ = *from++) && n-- );
  return((from - p) - 1);
}

int
getinput(char * buf, int max)
{
  int len;
  if( NULL == map )return(0);
  len = copyn(buf, map + used, max);
  used += len;
  flag_for_yywrap = (len?0:1);
  return(len);
}

void
putmessageid(char * text)
{
  char * id;
  char * cp;
  cp = text + 11;
  while( isspace(*cp) )cp++;
  if( '<' != *cp )return;
  cp++;
  id = cp;
  cp = strchr(id, '>');
  if( NULL == cp )return;
  *cp = '\0';
  printf("\001%s\n", id);
}

void
putword(char * text)
{
  char * cp;
  if( yyleng >= min_word_length && yyleng <= max_word_length ){
    for(cp = text; *cp; cp++)
      if( isupper(*cp) )*cp = tolower(*cp);
    printf("%s\n", text);
  }
}

int
yywrap(void)
{
  return(flag_for_yywrap);
}

int
main(int argc, char ** argv)
{
  int i;
  char * start = NULL;
  int argstart = 1;

  for(i = 1; i < argc; i++)
    if( '-' == *argv[i] )
      if( isdigit(argv[i][1]) ){
        char * cp;
        min_word_length = atoi(&argv[i][1]);
        cp = strchr(argv[i] + 1, '-');
        if( cp )max_word_length = atoi(cp + 1);
        argstart = 2;
      }else{
        fprintf(stderr, "Usage: %s [-n-m] files ...\nwhere "
          "n is the minimum word length, m is the max.\n", argv[0]);
        exit(1);
      }

  for(i = argstart; i < argc; i++){
    struct stat st;
    int fd;
    if( -1 == stat(argv[i], &st) ){
      fprintf(stderr, "Can't stat %s\n", argv[i]);
      continue;
    }
    if( ! S_ISREG(st.st_mode) ){
      fprintf(stderr, "%s is not a regular file\n", argv[i]);
      continue;
    }
    fd = open(argv[i], O_RDONLY);
    if( -1 == fd ){
      fprintf(stderr, "Can't open %s: %s\n", argv[i], strerror(errno));
      continue;
    }
    start = mmap(0, st.st_size, PROT_READ, MAP_FILE|MAP_PRIVATE, fd, 0);
    if( (int)start <= 0 ){
      fprintf(stderr, "Can't mmap %s: %s\n", argv[i], strerror(errno));
      continue;
    }
    for(map = start; map < start + st.st_size; map += (strlen(map) + 2)){
      used = 0;
      yyrestart(NULL);
      yylex();
    }
    munmap(map, st.st_size);
    close(fd);
  }
  exit(0);
}
